// https://htmlformatter.com/ 
// https://www.hackster.io/brzi/nodemcu-websockets-tutorial-3a2013
// https://www.tutorialspoint.com/websockets/websockets_send_receive_messages.htm
var ipValue;
var connection;
var ServerList = [];
var ServerListCnt = 0;

function init() {
    ResizeGUI();
    //alert("Hello! I am an alert box!!");
}

function ResizeGUI() {
    var elem = document.getElementById('HATable');
    properties = window.getComputedStyle(elem, null);
    Tableheight = properties.height;
    Tablewidth = properties.width;

    var sw = parseFloat(window.screen.width);
    var tw = parseFloat(Tablewidth);

    var sh = parseFloat(window.screen.height);
    var th = parseFloat(Tableheight);

    var InScaleWidthBased = parseFloat((sw / tw)).toFixed(2); //calculate ratio based on width
    var InScaleHeightBased = parseFloat((sh / th)).toFixed(2); //calculate ratio based on width
    if (InScaleWidthBased < InScaleHeightBased) {
        var InScale = InScaleWidthBased;
    } else {
        var InScale = InScaleHeightBased;
    }

    if (InScale < 3) {
        var viewport_meta_tag = document.getElementById('viewport');
        viewport_meta_tag.setAttribute('content', 'width=device-width, target-densitydpi=device-dpi,' + ' initial-scale=' + InScale + ', maximum-scale=' + '3' + ', user-scalable=yes');
        // Enable for Debug alert("InScale = " + InScale);
    }
}

//ok, i need to update viewport scale if screen dimensions changed
window.addEventListener('resize', function() {
    //ResizeGUI();
});

function SendtoWebSocket() {
    var cmdstr = document.getElementById('txttosend').value;
    //alert(cmdstr);
    SendCommandWebSocket(cmdstr);
};

function SendCommandWebSocket(cmd) {
    connection.send(cmd + "\n");
};

function ConnecttoWebsocketServer() {
    var text = document.getElementById('ip').value;
    ipValue = text;

    connection = new WebSocket(ipValue, ['arduino']);


    connection.onopen = function(evt) {
        onOpen(evt)
    };
    connection.onclose = function(evt) {
        onClose(evt)
    };
    connection.onmessage = function(evt) {
        onMessage(evt)
    };
    connection.onerror = function(evt) {
        onError(evt)
    };
}

function ConnecttoThisWebsocketServer(MDNSName, port, iconID) {
    var ipValue = "ws://" + MDNSName + ".local:" + port + "/"; //ws://5ccf7fb55ecc.local:81/	
    document.getElementById(iconID).style.color = "white";
    //alert(ipValue);
    connection = new WebSocket(ipValue, ['arduino']);

    connection.onopen = function(evt) {
        onOpen(evt, iconID)
    };
    connection.onclose = function(evt) {
        onClose(evt, iconID)
    };
    connection.onmessage = function(evt) {
        onMessage(evt)
    };
    connection.onerror = function(evt) {
        onError(evt, iconID)
    };
}

function DisconnecttoWebsocketServer() {
    connection.close();
}

function onOpen(evt, iconID1) {
    connection.send('Message from Browser to ESP8266 yay its Working!! ' + new Date());
    document.getElementById(iconID1).style.color = "green";
}

function onClose(evt, iconID1) {
    document.getElementById(iconID1).style.color = "gray";
}

function onMessage(evt) {
    var datastr = evt.data;
    alert(datastr);
}

function onError(evt, iconID1) {
    document.getElementById(iconID1).style.color = "white";
    alert("WebSocket Error" + error);
}

// web socket find https://stackoverflow.com/questions/27215757/javascript-find-local-websocket-servers
function findServers(port, ipBase, ipLow, ipHigh, maxInFlight, timeout, cb) {
    var ipCurrent = +ipLow,
        numInFlight = 0,
        servers = [];
    ipHigh = +ipHigh;

    function tryOne(ip) {
		document.getElementById('PBIPScanStatus').value = ip;
        ++numInFlight;
        var address = "ws://" + ipBase + ip + ":" + port;
        var socket = new WebSocket(address);
        var timer = setTimeout(function() {
            //document.getElementById('rxConsole').value += (address + " timeout\n"); //works but we dont want to log to textbox
            var s = socket;
            socket = null;
            s.close();
            --numInFlight;
            next();
        }, timeout);
        socket.onopen = function() {
            if (socket) {
                //document.getElementById('rxConsole').value += (address + " success\n");	//works but we dont want to log to textbox
                ServerList[ServerListCnt++] = address; // Get List of servers in variable ServerList				
                clearTimeout(timer);
                servers.push(socket.url);
                --numInFlight;
                next();
            }
        };
        socket.onerror = function(err) {
            if (socket) {
                //document.getElementById('rxConsole').value += (address + " error\n");		//works but we dont want to log to textbox 
                clearTimeout(timer);
                --numInFlight;
                next();
            }
        };
        //Added by me
        socket.onmessage = function(evt1) {
            if (socket) {
                var datastr1 = evt1.data;
                //alert(datastr1);  //working
				ProcessCommand(datastr1);
            }
        };
    }

    function next() {
        while (ipCurrent <= ipHigh && numInFlight < maxInFlight) {
            tryOne(ipCurrent++);
        }
        // if we get here and there are no requests in flight, then
        // we must be done
        if (numInFlight == 0) {
            //document.getElementById('rxConsole').value += console.log(servers);		//works but we dont want to log to textbox
            cb(servers);
        }
    }
    next();
}

function SearchWSServers(textscanip) {
	ServerListCnt = 0;
	ServerList.splice(0,ServerList.length);
	document.getElementById('PBIPScanStatus').value = 0;
    findServers(81, textscanip, 1, 255, 20, 4000, function(servers) {
        //document.getElementById('rxConsole').value += servers;		//check requirement works but we dont want to log to textbox	
    });
}

function ProcessCommand(CommandString) {
    //https://www.w3schools.com/jsref/jsref_split.asp 
    var PosStartChar = CommandString.indexOf("*"); //0 position starts with 0
    var PosEndChar = CommandString.indexOf("#"); //4
    var cmdRCVD = CommandString.substring(PosStartChar, CommandString.length);
    if ((PosStartChar >= 0) && (PosEndChar != 0) && (PosEndChar > PosStartChar)) {
        var res = cmdRCVD.split(","); //res -> will hold entire string and it array holds individual item starts with res[0] 				
        var cmd = parseInt(res[0].substring(PosStartChar + 1, PosEndChar));       

        switch (cmd) {
            case 0:

                break;

            case 1:

                break;

            case 243:
                //alert("Cmd 243 received" + "\n" + res[1] + "\n" + res[2] + "\n" + res[3]);
				alert("Nos of WebSocket Server Founds = " + ServerListCnt);
				if (ServerListCnt > 0) {
					var i;
					for (i = 0; i < ServerListCnt; i++) { //ServerList.length
						alert(ServerList[i]);
					}
				}
                break;
        }

    }
}

function ControlRelay(RelayNo, OnOrOff) {
    // 0 - Off, 1 - On , revised in r187
    var cmdstr;
    if (OnOrOff == 1) {
        cmdstr = "*321#," + RelayNo;
    } else {
        cmdstr = "*322#," + RelayNo;
    }
    SendCommandWebSocket(cmdstr);
}

function FanOn(OnOrOff) {
    var cmdstr;
    if (OnOrOff == 1) {
        SendCommandWebSocket("*323#");
    } else {
        SendCommandWebSocket("*324#");
    }
}

function SetFanSpeed(Speedval) {
    SendCommandWebSocket("*325#," + Speedval);
}

// https://stackoverflow.com/questions/22001674/inline-javascript-onclick-function